ICode9

精准搜索请尝试: 精确搜索
首页 > 其他分享> 文章详细

NC24158 [USACO 2015 Jan G]Moovie Mooving

2022-09-04 02:00:08  阅读:135  来源: 互联网

标签:20 int movie USACO Jan Moovie time dp first


题目链接

题目

题目描述

Bessie is out at the movies. Being mischievous as always, she has decided to hide from Farmer John for L (1 <= L <= 100,000,000) minutes, during which time she wants to watch movies continuously. She has N (1 <= N <= 20) movies to choose from, each of which has a certain duration and a set of showtimes during the day. Bessie may enter and exit a movie at any time during one if its showtimes, but she does not want to ever visit the same movie twice, and she cannot switch to another showtime of the same movie that overlaps the current showtime. Help Bessie by determining if it is possible for her to achieve her goal of watching movies continuously from time 0 through time L. If it is, determine the minimum number of movies she needs to see to achieve this goal (Bessie gets confused with plot lines if she watches too many movies).

输入描述

The first line of input contains N and L.
The next N lines each describe a movie. They begin with its integer duration, D (1 <= D <= L) and the number of showtimes, C (1 <= C <= 1000). The remaining C integers on the same line are each in the range 0..L, and give the starting time of one of the showings of the movie. Showtimes are distinct, in the range 0..L, and given in increasing order.

输出描述

A single integer indicating the minimum number of movies that Bessie needs to see to achieve her goal. If this is impossible output -1 instead.

示例1

输入

4 100
50 3 15 30 55
40 2 0 65
30 2 20 90
20 1 0

输出

3

备注

Bessie should attend the first showing of the fourth movie from time 0 to time 20. Then she watches the first showing of the first movie from time 20 to time 65. Finally she watches the last showing of the second movie from time 65 to time 100.

题解

知识点:状压dp,二分。

TSP问题的变种,变化在于每个点都有不同条件以及对应的不同贡献,选择一个作为下一个点时,需要选择这个点的最优解贡献,可以在排序的情况下二分查找。

这道题需要选择一个电影后,查找这个电影合法且最佳播放时间,如果不存在一个合法的就不能选这个点。

时间复杂度 \(O(2^n\sum \log c_i)\)

空间复杂度 \(O(2^n + \sum c_i)\)

代码

#include <bits/stdc++.h>

using namespace std;

int d[27], c[27][1007];
int dp[(1 << 20) + 7];

int main() {
    std::ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int N, L;
    cin >> N >> L;
    for (int i = 1;i <= N;i++) {
        cin >> d[i];
        cin >> c[i][0];
        for (int j = 1;j <= c[i][0];j++)
            cin >> c[i][j];
    }
    memset(dp, -0x3f, sizeof(dp));
    dp[0] = 0;
    int ans = ~(1 << 31);
    for (int i = 0;i < (1 << N);i++) {
        for (int j = 1;j <= N;j++) {
            if (!(i & (1 << (j - 1))) || dp[i ^ (1 << (j - 1))] < 0) continue;///实际上不用判断上一个状态存不存在,因为如果不存在导致这一次从0开始加了,那一定存在一种更小的方案,所以也不影响答案
            int k = upper_bound(c[j] + 1, c[j] + c[j][0] + 1, dp[i ^ (1 << (j - 1))]) - c[j] - 1;///持续时间固定,找到开始时间最接近的
            if (k) dp[i] = max(dp[i], c[j][k] + d[j]);///存在k直接选,则开始时间+持续时间和已有最大值比较,如果小了,选了也不影响最终答案
        }
        if (dp[i] >= L) ans = min(ans, __builtin_popcount(i));
    }
    cout << (ans > N ? -1 : ans) << '\n';
    return 0;
}

标签:20,int,movie,USACO,Jan,Moovie,time,dp,first
来源: https://www.cnblogs.com/BlankYang/p/16654147.html

本站声明: 1. iCode9 技术分享网(下文简称本站)提供的所有内容,仅供技术学习、探讨和分享;
2. 关于本站的所有留言、评论、转载及引用,纯属内容发起人的个人观点,与本站观点和立场无关;
3. 关于本站的所有言论和文字,纯属内容发起人的个人观点,与本站观点和立场无关;
4. 本站文章均是网友提供,不完全保证技术分享内容的完整性、准确性、时效性、风险性和版权归属;如您发现该文章侵犯了您的权益,可联系我们第一时间进行删除;
5. 本站为非盈利性的个人网站,所有内容不会用来进行牟利,也不会利用任何形式的广告来间接获益,纯粹是为了广大技术爱好者提供技术内容和技术思想的分享性交流网站。

专注分享技术,共同学习,共同进步。侵权联系[81616952@qq.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有